<?php
/*
+---------------------------------------------------------------------------
|   Invision Power Board
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2009 Invision Power Services, Inc.
|   http://www.invisionpower.com
|   =============================================
|   Web: http://www.invisionboard.com
|   Licence Info: http://www.invisionboard.com/?license
+---------------------------------------------------------------------------
|
|   > Thanks Admin Center component
|   > Module written by andaril http://ipbskins.ru
|   > Date started: 26.03.2009
|   > Module Version Number: 2.2.0
|
+--------------------------------------------------------------------------- 
|   > Last update: $Date:: 2009-07-18 13:01:30 +0400#$
|   > $Revision: 23 $
|   > $Author: a1 $ 
+---------------------------------------------------------------------------
*/

if ( ! defined( 'IN_ACP' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

class ad_thanks
{
	//  
	var $ipsclass;
	
	/**
	* auto_run function
	*/

	function auto_run()
	{
	
		//  
		$this->ipsclass->acp_load_language( 'acp_lang_thanks' );
		
		$this->ipsclass->admin->page_title = $this->ipsclass->acp_lang['thx_main_title'];			
		$this->ipsclass->admin->page_detail = $this->ipsclass->acp_lang['thx_main_detail']; //    
		
		$this->ipsclass->admin->nav[] = array('section=components&act=thanks' , $this->ipsclass->acp_lang['thx_main_nav']);
		
		// What we do, baby?
		switch( $this->ipsclass->input['code'] )
		{
			// 
		 	case 'settings':
				$this->settings();
				break;

			// GUI 
		 	case 'tools':
			 	$this->tools_gui();
				break;
			
			//   " "
		 	case 'thx_resync_thanks_count':
			 	$this->resync_thanks_count();
				break;
			
			//   ""
		 	case 'thx_resync_thanks_gived':
			 	$this->resync_thanks_gived();
				break;
				
			//    Thanks Mod Light 2.3 (ajax) - Adapted by ThiagoInfo
		 	case 'import_from_athx_light':
			 	$this->import_from_athx_light();
				break;
				
			//   10  +1  "" (-
		 	case 'inc_rep_count':
			 	$this->inc_rep_count();
				break;
			
			//  ,     ,  ,      
		  	default:
			 	$this->tools_gui();
				break;
		}
		
	}
	
	/*-------------------------------------------------------------------------*/
    //               
    /*-------------------------------------------------------------------------*/ 
	
	function settings()
	{		
		require_once(ROOT_PATH . 'sources/action_admin/settings.php');
		$settings = new ad_settings();
		$settings->ipsclass = &$this->ipsclass;
		$settings->get_by_key = 'thanksmodsettings';
		$settings->return_after_save = $this->ipsclass->form_code . "&amp;code=settings";
		$settings->setting_view();
	}
	
	/*-------------------------------------------------------------------------*/
    //            
    /*-------------------------------------------------------------------------*/ 
	
	function tools_gui()
	{		
	
		//-------------------------------------
		//   
		//-------------------------------------
		
		//   ?
		//  ,  .   name='act'  value='thanks'  ?
		$this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'act'  , 'thanks'      ),
																			 2 => array( 'code' , 'thx_resync_thanks_count'  ),
																			 4 => array( 'section', $this->ipsclass->section_code ),
													    			)      );

		//     .      
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "70%" );
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "30%" );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->start_table( $this->ipsclass->acp_lang['thx_resync_count'] );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( $this->ipsclass->acp_lang['thx_resync_count_desc'],
																			 $this->ipsclass->acp_lang['thx_per_cicle'] . $this->ipsclass->adskin->form_simple_input( 'pergo', '300', 5 ),
																	)      );
		
		//    ""
		$this->ipsclass->html .= $this->ipsclass->adskin->end_form($this->ipsclass->acp_lang['thx_do_it_baby']);
		$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		/*
		//-------------------------------------
		//  "    "
		//-------------------------------------
		
		if($this->ipsclass->vars['thx_count_gived'])
		{
			$this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'act'  , 'thanks'      ),
																				 2 => array( 'code' , 'thx_resync_thanks_gived'  ),
																				 4 => array( 'section', $this->ipsclass->section_code ),
																		)      );

		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "70%" );
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "30%" );
			
			$this->ipsclass->html .= $this->ipsclass->adskin->start_table( $this->ipsclass->acp_lang['thx_resync_gived'] );
			
			$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( $this->ipsclass->acp_lang['thx_resync_gived_desc'],
																				 $this->ipsclass->acp_lang['thx_per_cicle'] . $this->ipsclass->adskin->form_simple_input( 'pergo', '50', 5 ),
																		)      );
			
			$this->ipsclass->html .= $this->ipsclass->adskin->end_form($this->ipsclass->acp_lang['thx_do_it_baby']);
			$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		}
		
		//-------------------------------------
		//    +1  ,   10 
		//-------------------------------------
		
		if($this->ipsclass->vars['thx_inc_rep'] AND $this->ipsclass->vars['thx_inc_rep_on'] > 0)
		{
			$this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'act'  , 'thanks'      ),
																				 2 => array( 'code' , 'inc_rep_count'  ),
																				 4 => array( 'section', $this->ipsclass->section_code ),
																		)      );

		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "70%" );
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "30%" );
			
			$this->ipsclass->html .= $this->ipsclass->adskin->start_table( $this->ipsclass->acp_lang['thx_inc_rep'] );
			
			$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( $this->ipsclass->acp_lang['thx_inc_rep_desc'],
																				 $this->ipsclass->acp_lang['thx_per_cicle'] . $this->ipsclass->adskin->form_simple_input( 'pergo', '50', 5 ),
																		) 		);
			
			$this->ipsclass->html .= $this->ipsclass->adskin->end_form($this->ipsclass->acp_lang['thx_do_it_baby']);
			$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		}
		
		//-------------------------------------
		//    thx ajax light
		//-------------------------------------
		/*
		$this->ipsclass->html .= $this->ipsclass->adskin->start_form( array( 1 => array( 'act'  , 'thanks'      ),
																			 2 => array( 'code' , 'import_from_athx_light'  ),
																			 4 => array( 'section', $this->ipsclass->section_code ),
													    			)      );

		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "70%" );
		$this->ipsclass->adskin->td_header[] = array( "&nbsp;"    , "30%" );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->start_table( $this->ipsclass->acp_lang['thx_import_from_athxl'] );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->add_td_row( array( $this->ipsclass->acp_lang['thx_import_from_athxl_desc'],
																			 $this->ipsclass->acp_lang['thx_per_cicle'] . $this->ipsclass->adskin->form_simple_input( 'pergo', '50', 5 ),
																	)      );
		
		$this->ipsclass->html .= $this->ipsclass->adskin->end_form($this->ipsclass->acp_lang['thx_do_it_baby']);
		$this->ipsclass->html .= $this->ipsclass->adskin->end_table();
		*/
		
		// , - 
		$this->ipsclass->admin->output();
	}
	
	/*-------------------------------------------------------------------------*/
    //   
    /*-------------------------------------------------------------------------*/ 
	
	function inc_rep_count()
	{		
		$this->ipsclass->html = '.     ?';
		// , - 
		$this->ipsclass->admin->output();
	}
	
	/*-------------------------------------------------------------------------*/
    //     
    /*-------------------------------------------------------------------------*/ 
	
	function resync_thanks_gived()
	{		
		$this->ipsclass->html = '.     ?';
		// , - 
		$this->ipsclass->admin->output();
	}
	
	/*-------------------------------------------------------------------------*/
    //   
    /*-------------------------------------------------------------------------*/ 
	
	function import_from_athx_light()
	{		
		$this->ipsclass->html = '.     ?';
		// , - 
		$this->ipsclass->admin->output();
	}
	
	/*-------------------------------------------------------------------------*/
    //      
    /*-------------------------------------------------------------------------*/ 
	
	function resync_thanks_count()
	{		
		//-----------------------------------------
		// 
		//-----------------------------------------
		
		$done   = 0;
		$start  = intval($this->ipsclass->input['st']) >=0 ? intval($this->ipsclass->input['st']) : 0;
		$end    = intval( $this->ipsclass->input['pergo'] ) ? intval( $this->ipsclass->input['pergo'] ) : 200;
		$dis    = $end + $start;
		
		//-----------------------------------------
		// ?
		//-----------------------------------------
		
		$tmp = $this->ipsclass->DB->simple_exec_query( array( 'select' => 'id', 'from' => 'members', 'limit' => array($dis,1)  ) );
		$max = intval( $tmp['id'] );
		
		//-----------------------------------------
		//  
		//-----------------------------------------
		
		$this->ipsclass->DB->simple_construct( array( 	'select' => 'id, name', 
														'from' 	 => 'members', 
														'order'  => 'id ASC', 
														'limit'  => array($start,$end) 
											)		);
		$outer = $this->ipsclass->DB->simple_exec();
		
		//-----------------------------------------
		// 
		//-----------------------------------------
		
		while( $r = $this->ipsclass->DB->fetch_row( $outer ) )
		{
			$new_thx_count = 0;
			$this->ipsclass->DB->build_query( array( 'select' 	=> 'post_thanks',
													 'from'		=> 'posts',
													 'where'	=> 'post_thanks <> \'\' AND author_id='.$r['id'],
											)		);
			$qid = $this->ipsclass->DB->exec_query();
							
			while($row = $this->ipsclass->DB->fetch_row($qid))
			{
				$new_thx_count += count( explode(',',$row['post_thanks']) );
			}
			
			$new_thx_count = intval( $new_thx_count );
			$this->ipsclass->DB->do_update( 'members', array( 'thanks_point' => $new_thx_count ), 'id='.$r['id'] );
			$done++;
		}
		
		//-----------------------------------------
		//   ?
		//-----------------------------------------
		
		if ( ! $done and ! $max )
		{
			$text = $this->ipsclass->acp_lang['thx_resync_finish'];
			$url  = "{$this->ipsclass->form_code}";
			$time = 3;
		}
		else
		{
			$text = str_replace('<#num#>', $dis, $this->ipsclass->acp_lang['thx_resync_do']);
			$url  = "{$this->ipsclass->form_code}&code=".$this->ipsclass->input['code'].'&pergo='.$this->ipsclass->input['pergo'].'&st='.$dis;
			$time = 0;
		}
		
		//-----------------------------------------
		// Bye...
		//-----------------------------------------
		
		$this->ipsclass->admin->redirect( $url, $text, 0, $time );
	}
	
} // 
?>