<?php

/*
+---------------------------------------------------------------------------
|   Invision Power Board
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2009 Invision Power Services, Inc.
|   http://www.invisionpower.com
|   =============================================
|   Web: http://www.invisionboard.com
|   Licence Info: http://www.invisionboard.com/?license
+---------------------------------------------------------------------------
|
|   > Thanks component
|   > Module written by andaril http://ipbskins.ru
|   > Date started: 12.08.2006
|   > Module Version Number: 2.2.0
|
+--------------------------------------------------------------------------- 
|   > Last update: $Date:: 2009-08-13 18:31:50 +0400#$
|   > $Revision: 27 $
|   > $Author: a1 $ 
+---------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

//  
class component_public
{
	//   
	var $ipsclass;
	//  class_ajax
	var $class_ajax;
	//  ?
	var $ajaxInUse = 0;
	
	// 
	var $nav   = array();	
	
	/*-------------------------------------------------------------------------*/
    //  .   index.php               
    /*-------------------------------------------------------------------------*/ 
    
	function run_component()
	{
	
		//  		
		$this->ipsclass->load_language('lang_thanks');		
		
		//  INIT
		if( !is_object( $this->ipsclass->compiled_templates['skin_global'] ) ) 
		{
			$this->ipsclass->load_template( 'skin_global' );
		}
		if( !isset( $this->ipsclass->lang['thanks_mod'] ) ) 
		{
			$this->ipsclass->load_language( 'lang_global' );
			if( !isset( $this->ipsclass->lang['thanks_mod'] ) ) 
				$this->ipsclass->lang['thanks_mod'] = '';
		}
		
		//   ? 0_
		if (!$this->ipsclass->vars['thanks_mod_enable'])
		{
			$this->showMessage( array('msg' => 'thx_thanks_disabled', 'std' => 1) );
		}
		
		// 
		$this->nav[] = $this->ipsclass->lang['thx_top_list'];
		
		//   ?
		switch($this->ipsclass->input['type'])
		{
			// 
			case 'add':
				if($this->ipsclass->input['xmlinuse'] AND isset($this->ipsclass->input['xmlinuse']))
				{
					//    
					$this->ajaxInUse = 1;

					//      
					require_once( KERNEL_PATH . 'class_ajax.php' );
					$this->class_ajax           =  new class_ajax();
					$this->class_ajax->ipsclass =& $this->ipsclass;
					$this->class_ajax->class_init();
				}
				$this->thanks_add();
				break;
				
			// 
			case 'delete':
				if($this->ipsclass->input['xmlinuse'] AND isset($this->ipsclass->input['xmlinuse']))
				{
					//    
					$this->ajaxInUse = 1;

					//      
					require_once( KERNEL_PATH . 'class_ajax.php' );
					$this->class_ajax           =  new class_ajax();
					$this->class_ajax->ipsclass =& $this->ipsclass;
					$this->class_ajax->class_init();
				}
				$this->thanks_delete();
				break;
			
			//   
			case 'history':
				$this->thanks_history();
				break;
			case 'edit_list':
				$this->thanks_edit_list();
				break;
			case 'edit_count':
				$this->thanks_edit_count();
				break;
			case 'recount':
				$this->thanks_recount();
				break;
			case 'top_users':
				$this->top_users();
				break;
			default:
				//$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_wrong_input'], "act=idx" );
				$this->top_users();
				break;
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //  ""              
    /*-------------------------------------------------------------------------*/ 
    
	function thanks_add()
	{
		// 
		$post_id = intval($this->ipsclass->input['pid']);
		$topic_id = intval($this->ipsclass->input['t']);
		$forum_id = intval($this->ipsclass->input['f']);
		
		if ( (!$post_id) or (!$topic_id) or (!$forum_id) )
		{
			$this->showMessage( array('msg' => 'missing_files', 'std' => 1));
		}
		
		//  ,    
		$post = $this->ipsclass->DB->simple_exec_query( array(  'select' => 'post_thanks, topic_id, author_id', 
																'from'   => 'posts', 
																'where'  => 'pid = ' . $post_id 
													  ) 	);
													  
		//  
		if ( (!$post['topic_id']) or ($post['topic_id'] != $topic_id) )
		{
			$this->showMessage( array('msg' => 'no_permission', 'std' => 0 ));
		}
		
		//    
		if ($post['author_id'])
		{
			$repsys = ( $this->ipsclass->vars['thx_inc_rep'] 
						AND $this->ipsclass->vars['thx_inc_rep_on'] > 0 
						AND isset($this->ipsclass->vars['rep_posts']) 
						AND is_numeric($this->ipsclass->vars['rep_posts']) ) 
						? ', id, members_display_name, rep_notify, reputation, rep_off' : '';
			
			//    
			$author = $this->ipsclass->DB->simple_exec_query( array(    'select' => "mgroup, thanks_point {$repsys}", 
																		'from'   => 'members', 
																		'where'  => 'id = ' . $post['author_id'] 
															) 		);
		}
		else
		{
			//   - 
			$author['mgroup'] = $this->ipsclass->vars['guest_group'];
			$author['thanks_point'] = 0;
		}
		
		//  
		if (   ( ($this->ipsclass->vars['thanks_forum_lim']) and (!in_array($forum_id, explode(',',$this->ipsclass->vars['thanks_forums']))) )
			or ( ($this->ipsclass->vars['thanks_from_grp_lim']) and (!in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_from_groups']))) )
			or ( ($this->ipsclass->vars['thanks_to_grp_lim']) and (!in_array($author['mgroup'], explode(',',$this->ipsclass->vars['thanks_to_groups']))) )
			or (!$this->ipsclass->member['id'])   )
		{
			$this->showMessage( array('msg' => 'no_permission', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
		
		//  ?    ?
		if ( $this->ipsclass->member['id'] == $post['author_id'] ) 
		{
			$this->showMessage( array('msg' => 'no_thx_itself', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ));
		}
		
		//  ,   ""
		$member_thanks = explode( ',', $post['post_thanks'] );
		
		// , ,   
		if ( in_array($this->ipsclass->member['id'], $member_thanks) ) 
		{
			$this->showMessage( array('msg' => 'no_2_thx', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
		
		//    . ,  , 
		$insert_thanks = ( $post['post_thanks'] == "" ) ? ( $this->ipsclass->member['id'] ) : ( $post['post_thanks'] . "," . $this->ipsclass->member['id'] );
		
		$this->ipsclass->DB->do_update( 'posts', array( 'post_thanks' => $insert_thanks), 'pid = ' . $post_id );
		if ($post['author_id'])
		{
			$this->ipsclass->DB->do_update( 'members', array( 'thanks_point' => $author['thanks_point']+1 ), 'id = ' . $post['author_id'] );
		}
		/*
		//   
		if( $this->ipsclass->vars['thx_inc_rep'] 
			AND $this->ipsclass->vars['thx_inc_rep_on'] > 0 
			AND isset($this->ipsclass->vars['rep_posts']) 
			AND is_numeric($this->ipsclass->vars['rep_posts']) )
		{
			$author['thanks_point']++;
			if($author['thanks_point'] % $this->ipsclass->vars['thx_inc_rep_on'] == 0)
			{
				$this->reputation_add($author);
			}
		}
		*/
		// 
		if ($this->ajaxInUse == 1)
		{		
			//   
			$in_thanks = ((isset($post['post_thanks']) AND $post['post_thanks'] !== '') AND ($this->ipsclass->member['id'] !== 0) AND (is_array($member_thanks) AND count($member_thanks))) ? $post['post_thanks'].','.$this->ipsclass->member['id'] : $this->ipsclass->member['id'];

			//  ^^
			$this->class_ajax->return_html( $this->format_list($in_thanks, $post_id, $topic_id, $post['author_id']) );
		}
		else
		{
			$this->showMessage( array('msg' => 'thx_added', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //    1   N 
    //  eXtended RepSys
	/*-------------------------------------------------------------------------*/ 
	
	function reputation_add($member = array())
	{
		if( is_numeric($member['id']) 
			AND intval($member['id']) <= 0) return;
		if($member['rep_off']) return;
				
		//   
		$this->ipsclass->DB->do_insert('reputation',array(  'from_user' => 0,
															'to_user'   => $member['id'],
															'post'      => 0,
															'topic'     => 0,
															'message'   => $this->ipsclass->lang['thx_rep_inc_desc'],
															'rating'    => 1,
															'created'   => time()));

		$this->ipsclass->DB->simple_update('members', "reputation=reputation+1", 'id='.$member['id'] );
		$this->ipsclass->DB->simple_exec();

		// 
		if ($member['rep_notify'])
		{
			//        .
			require_once( ROOT_PATH.'sources/lib/func_msg.php' );

			$this->lib = new func_msg();
			$this->lib->ipsclass =& $this->ipsclass;

			$this->lib->init();

			$this->lib->to_by_id    = $member['id'];
			$this->lib->from_member['id'] = $this->ipsclass->vars['rep_pmid'];
			$this->lib->msg_title   = $this->ipsclass->lang['thx_rep_notify_title'];
			$this->lib->msg_post    = $this->ipsclass->lang['thx_rep_inc'];
			$this->lib->force_pm    = 0;

			$this->lib->send_pm();

			if ( $this->lib->error )
			{
				return;
			}
		}
		return;
	}
	
	/*-------------------------------------------------------------------------*/
    //    ""  
    /*-------------------------------------------------------------------------*/ 
	
	function format_list( $who, $pid, $topic_id, $post_mid )
	{
		//    -  
		if ( $who == '' OR $pid == '' OR $topic_id == '') return '';
		
		//    ?
		if ( ( in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_view_groups'])) 
		OR !$this->ipsclass->vars['thanks_view_grp_lim'] ) )
		{
			//  
			$this->ipsclass->DB->simple_construct( array( 'select'  => 'members_display_name, id, mgroup',
														  'from'	=> 'members',
														  'where'   => " id IN ({$who})",
												 )		);
			$qid = $this->ipsclass->DB->simple_exec();

			// ,     
			while($who_thanks = $this->ipsclass->DB->fetch_row($qid))
			{
				$who_thanks['members_display_name'] = $this->ipsclass->make_name_formatted( $who_thanks['members_display_name'], $who_thanks['mgroup'] );
				
				//     :)
				//              
				if($this->ipsclass->input['type'] != 'history')
					$delete_img = ( $this->edit_permissions() OR ($who_thanks['id'] == $this->ipsclass->member['id'])) ? "&nbsp;<a href='{$this->ipsclass->base_url}autocom=thanks&amp;type=delete&amp;pid={$pid}&amp;t={$topic_id}' onclick='return thx_delete({$who_thanks['id']}, {$pid}, {$post_mid});' ><img id='thx_img_{$pid}_{$who_thanks['id']}' src='style_images/<#IMG_DIR#>/thx_del_inactive.gif' alt='{$this->ipsclass->lang['thx_delete_action']}' onMouseOver='document.getElementById(\"thx_img_{$pid}_{$who_thanks['id']}\").src=\"style_images/<#IMG_DIR#>/thx_del_active.gif\"' onMouseOut='document.getElementById(\"thx_img_{$pid}_{$who_thanks['id']}\").src=\"style_images/<#IMG_DIR#>/thx_del_inactive.gif\"' /></a>" : "";
				
				$show_thanks .= "<a href='{$this->ipsclass->base_url}showuser={$who_thanks['id']}' target='_blank'>{$who_thanks['members_display_name']}</a>{$delete_img}, ";
			}
			
			//      :)
			$show_thanks = preg_replace( "/, $/", "", $show_thanks );
		
			if($this->ipsclass->input['type'] != 'history')
				return "<div id='thank{$pid}'><br /><br /><div class='thin'><i>{$this->ipsclass->lang['thx_thanks_told']}:</i><div class='signature'>{$show_thanks}</div></div></div>";
			else
				return "{$show_thanks}";
		}
		else
		{
			//  ,    
			$this->showMessage( array('msg' => 'thx_added', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$pid}" ) );
		}
	}
		
	/*-------------------------------------------------------------------------*/
    //  .      
    // -    
    //       , ,         .       
    /*-------------------------------------------------------------------------*/ 
	/*
	function members_by_id_list($id_list = "")
	{
		$members_list = "";
		if ($id_list)
		{
			// Read Name by ID...
			$this->ipsclass->DB->simple_construct( array( 	'select' => 'id, members_display_name, mgroup', 
															'from'   => 'members', 
															'where'  => 'id IN (' . $id_list . ')',
															'order'  => 'members_display_name ASC'
												 ) 		);
			$this->ipsclass->DB->simple_exec();
			
			while($who_thanks = $this->ipsclass->DB->fetch_row())
			{
				// Build output code...
				$who_thanks['members_display_name'] = $this->ipsclass->make_name_formatted($who_thanks['members_display_name'], $who_thanks['mgroup']);
				$members_list .= "<a href='{$this->ipsclass->base_url}showuser={$who_thanks['id']}'>" . $who_thanks['members_display_name'] . "</a>" . ', ';
			}
		}
		// output
		return $members_list;
	}
	*/
	
	/*-------------------------------------------------------------------------*/
    //   / 
    /*-------------------------------------------------------------------------*/ 
	
	function edit_permissions()
	{
		// in_array()   bool ^^ 
		return (bool) (in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_moder_groups'])) 
						OR $this->ipsclass->member['g_is_supmod'] 
						OR $this->ipsclass->member['g_access_cp'] );
	}
	
	/*-------------------------------------------------------------------------*/
    //  "" 
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_history()
	{
		//   .    ,  
		if (!$this->ipsclass->vars['thanks_history_enable'])
		{
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_history_disabled'], "act=idx" );
		}
				
		// Input data
		$author_id = intval($this->ipsclass->input['mid']);
		$this->st = intval($this->ipsclass->input['st']);
		
		$html_output = "";
		$mod_th = "";
		
		// Read author's info
		$author = $this->ipsclass->DB->simple_exec_query( array( 'select' => 'members_display_name, mgroup, thanks_point',
																 'from'   => 'members',
																 'where'  => 'id = ' . $author_id
														) 		);
		
		// Column and header for editing
		if ( $this->edit_permissions() )
		{
			$mod_th = "<th align='center' width='10%'>{$this->ipsclass->lang['thx_edit']}:</th>";
			
			$html_output .= "
		<div class='borderwrap' align='center'>
			<form name='thanks_moder_main' action='{$this->ipsclass->base_url}autocom=thanks&amp;type=edit_count&amp;mid={$author_id}&amp;st={$this->st}' method='post'>
				{$this->ipsclass->lang['thx_thanks_told']}: <input type='text' name='thanks_edit' value='{$author['thanks_point']}' /> {$this->ipsclass->lang['thx_thanks_told_suf']} 
				<input class='button' type='submit' value='{$this->ipsclass->lang['thx_apply']}' />
				<input class='button' type='button' value='{$this->ipsclass->lang['thx_recount']}' OnClick='parent.location=\"{$this->ipsclass->base_url}autocom=thanks&amp;type=recount&amp;mid={$author_id}&amp;st={$this->st}\"' />
			</form>
		</div><br />";
		}
		
		// 
		$this->nav[] = $this->ipsclass->lang['thx_history_title']." {$author['members_display_name']}";
		
		// Tab's header
		$html_output .= "
		<div class='borderwrap'>
			<div class='maintitle'>" . $this->ipsclass->lang['thx_history_title'] . " " . $author['members_display_name'] . ". {$this->ipsclass->lang['thx_thanks_told']}: " . $author['thanks_point'] . " {$this->ipsclass->lang['thx_thanks_told_suf']}</div>
			<table class='ipbtable' cellspacing='1'>
				<tr>
					<th align='center' width='10%'>{$this->ipsclass->lang['thx_post_date']}:</th>
					<th align='center' width='20%'>{$this->ipsclass->lang['thx_in_topic']}:</th>
					<th align='center' width='40%'>{$this->ipsclass->lang['thx_post']}:</th>
					<th align='center'>{$this->ipsclass->lang['thx_thanks_told']}:</th>
					{$mod_th}
				</tr>
				";
		
		// Main query
		//        
		$this->ipsclass->DB->simple_construct( array( 	 'select'   => 'p.pid, p.topic_id, p.post_date, p.post, p.post_thanks, p.author_id, t.forum_id',
														 'from'     => array( 'posts' => 'p' ),
														 'where'    => 'p.author_id = ' . $author_id . ' and p.post_thanks <> \'\' ',
														 'add_join' => array( 0 => array( 	 'select' => 't.title, t.description',
																							 'from'   => array( 'topics' => 't' ),
																							 'where'  => 'p.topic_id = t.tid',
																							 'type'   => 'inner'
																			) 			),
														 'order'  => 'p.post_date DESC'
											) 		);
		
		//   .   ,   ,   300 ?
		if ($this->ipsclass->vars['thanks_perpage'])
		{
			//  .   
			$this->ipsclass->DB->simple_construct( array( 'limit' => array( $this->st, $this->ipsclass->vars['thanks_perpage'] ) ) );
		}
		
		$query_id = $this->ipsclass->DB->simple_exec();
				
		// BB-Code Parser
		//   !!!         2.3.,     , ..    ?        ...
		/*
		require_once( ROOT_PATH."sources/handlers/han_parse_bbcode.php" );
		$this->parser =  new parse_bbcode();
		$this->parser->ipsclass =& $this->ipsclass;
		$this->parser->allow_update_caches = 0;
		*/

		if ($this->ipsclass->DB->get_num_rows())
		{
			//     " "
			while($row = $this->ipsclass->DB->fetch_row($query_id))
			{
				//       ,    
				if(!$this->ipsclass->forums->forums_check_access( $row['forum_id'], 0, 'topic', 1 ))
				{
					$cols = ($mod_th) ? 'colspan="2"' : '';
					$html_output .= "<tr>
							<td class='row2' align='left'>" . $this->ipsclass->get_date($row['post_date'], 'LONG') . "</td>
							<td class='row2' align='center'>
								<i>{$this->ipsclass->lang['thx_no_access_topic']}</i>
							</td>
							<td class='row2' align='center'><div class='postcolor'><i>{$this->ipsclass->lang['thx_no_access_post']}</i></div></td>
							<td class='row2' align='left' {$cols}>".$this->format_list($row['post_thanks'], $row['pid'], $row['topic_id'], $row['author_id'])."</td>
						</tr>";
				}
				else
				{
					// 
					$mod_td = "";
					if ($mod_th)
					{
						$mod_td = "<td class='row1' align='center'>
								<form name='thanks_moder_{$row['pid']}' action='{$this->ipsclass->base_url}autocom=thanks&amp;type=edit_list&amp;mid={$author_id}&amp;st={$this->st}&amp;pid={$row['pid']}' method='post'>
									<input type='text' name='thanks_edit' value='{$row['post_thanks']}' /><br />
									<input class='button' type='submit' value='{$this->ipsclass->lang['thx_apply']}' />
								</form>
							</td>";
					}
					
					// Check for Hidden text by Vic'er
					/*
					//        
					if ( method_exists( $this->parser , "regex_hide_hidden" ) )
					{
						$row['post'] = $this->parser->regex_hide_hidden( $row['post'], $author_id );
					}
					
					$row['post'] = $this->parser->pre_display_parse( $row['post'] );
					*/
									
					$html_output .= "<tr>
							<td class='row2' align='left'>" . $this->ipsclass->get_date($row['post_date'], 'LONG') . "</td>
							<td class='row2' align='left'>
								<a href='{$this->ipsclass->base_url}showtopic={$row['topic_id']}&amp;view=findpost&amp;p={$row['pid']}' title='{$row['description']}'>{$row['title']}</a><br />
								<span class='desc'>{$row['description']}</span>
							</td>
							<td class='row2' align='left'><div class='postcolor' style='height: 80px; overflow: auto'>{$row['post']}</div></td>
							<td class='row2' align='left'>".$this->format_list($row['post_thanks'], $row['pid'], $row['topic_id'], $row['author_id'])."</td>
							{$mod_td}
						</tr>";
				}
			}
			unset($rows);
		}
		else
		{
			$html_output .= "<tr><td class='row2' align='center' colspan='6'>{$this->ipsclass->lang['thx_no_data']}</td></tr>";
		}
		
		// pagelinks || -:   
		if ( $this->ipsclass->vars['thanks_perpage'] )
		{
			$rows_count = 0;
			// Rows count
			//    .       ,    ,  /
			$rows_count = $this->ipsclass->DB->simple_exec_query( array( 'select' => 'count(p.pid)',
																		 'from'   => array( 'posts' => 'p' ),
																		 'where'  => 'p.author_id = ' . $author_id . ' and p.post_thanks <> \'\' ',
																	     'add_join' => array( 0 => array('from'   => array( 'topics' => 't' ),
																										 'where'  => 'p.topic_id = t.tid' . $perms_not_allow,
																										 'type'   => 'inner'
																							) 			)
																) 		);
			
			// Bild html-code
			$links = $this->ipsclass->build_pagelinks(  array(  'TOTAL_POSS'  => $rows_count['count(p.pid)'],
																'PER_PAGE'    => $this->ipsclass->vars['thanks_perpage'],
																'CUR_ST_VAL'  => $this->st,
																'L_SINGLE'     => "",
																'L_MULTI'      => $this->ipsclass->lang['pages'],
																'BASE_URL'     => $this->ipsclass->base_url."autocom=thanks&amp;type=history&amp;mid={$author_id}"
													)  		);
		}
		
		// Tab's footer
		$html_output .= "<tr><td class='catend' colspan='6'><!-- no content --></td></tr>
			</table>
		</div><br />
		{$links}";
		
		// Output
		$this->ipsclass->print->add_output($html_output);
		$this->ipsclass->print->do_output( array(   'TITLE' => $this->ipsclass->lang['thx_history_title'], 
													'JS'    => "<script type='text/javascript' src='jscripts/thx_js.js'></script>", 
													'NAV'   => array( $this->ipsclass->lang['thx_history_title'] ) 
										 ) 		);
	}
	
	/*-------------------------------------------------------------------------*/
    //     
    // -    
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_edit_list()
	{
		if ( $this->edit_permissions() )
		{
			// Input data
			$post_id = intval($this->ipsclass->input['pid']);
			$new_thanks_list = preg_replace( "#[^0-9,\,]#im", "", $this->ipsclass->input['thanks_edit'] );
			$new_thanks_list = preg_replace( "/([^\d]\,)|(^\,)|(\,$)/im", "", $new_thanks_list );
			
			// Update "post_thanks"
			$this->ipsclass->DB->do_update( 'posts', array( 'post_thanks' => $new_thanks_list), 'pid = ' . $post_id );
			
			// Redirect
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_edit_post_thanks'], "autocom=thanks&amp;type=history&amp;mid={$this->ipsclass->input['mid']}&amp;st={$this->ipsclass->input['st']}" );
		}
		else
		{
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_out_of_permissions'], "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" );
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //   
    // - 
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_edit_count()
	{
		if ( $this->edit_permissions() )
		{
			//  
			if (intval($this->ipsclass->input['mid']))
			{
				// Update "thanks_point"
				$this->ipsclass->DB->do_update( 'members', array( 'thanks_point' => intval($this->ipsclass->input['thanks_edit']) ), 'id = ' . intval($this->ipsclass->input['mid']) );
				// Redirect
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_edit_thanks_count'], "autocom=thanks&amp;type=history&amp;mid={$author_id}&amp;st={$this->ipsclass->input['st']}" );
			}
			else
			{
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_wrong_input'], "autocom=thanks&amp;type=history&amp;mid=".intval($this->ipsclass->input['mid'])."&amp;st={$this->ipsclass->input['st']}" );
			}
		}
		else
		{
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_out_of_permissions'], "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" );
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //  ""    
    // - 
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_recount()
	{
		if ( $this->edit_permissions() )
		{
			// Input data
			$author_id = intval($this->ipsclass->input['mid']);
			
			if ($author_id)
			{
				// Get "post_thanks"
				$this->ipsclass->DB->simple_construct( array( 	'select' => 'post_thanks', 
																'from'   => 'posts', 
																'where'  => 'author_id = ' . $author_id . ' and post_thanks <> \'\' ' 
													) 		);
				$this->ipsclass->DB->simple_exec();
				
				$thanks_count = 0;
				
				// Recount "post_thanks"
				while($row = $this->ipsclass->DB->fetch_row())
				{
					$thanks_count += count( explode(',',$row['post_thanks']) );
				}
				
				// Update "post_thanks"
				$this->ipsclass->DB->do_update( 'members', array( 'thanks_point' => $thanks_count ), 'id = ' . $author_id );
				
				// Redirect
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_recount_thanks'], "autocom=thanks&amp;type=history&amp;mid={$author_id}&amp;st={$this->ipsclass->input['st']}" );
			}
			else
			{
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_wrong_input'], "autocom=thanks&amp;type=history&amp;mid={$author_id}&amp;st={$this->ipsclass->input['st']}" );
			}
		}
		else
		{
			$this->ipsclass->print->redirect_screen( $this->ipsclass->lang['thx_out_of_permissions'], "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" );
		}
	}
	
	//     ,  thanks.php .  ,       .   ...    . (2:36  )
	
	/*-------------------------------------------------------------------------*/
    //  ""
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_delete()
	{
		// 
		$post_id 		= intval($this->ipsclass->input['pid']);
		$topic_id 		= intval($this->ipsclass->input['t']);
		//$forum_id 	= intval($this->ipsclass->input['f']);
		$thx_member_id  = intval($this->ipsclass->input['thx_mid']);
		
		if ( (!$post_id) or (!$topic_id) or (!$thx_member_id))
		{
			$this->showMessage( array('msg' => 'missing_files', 'std' => 1));
		}
		//    ?
		$can = 0;
		if($this->edit_permissions()) 						$can = 1;
		if($thx_member_id == $this->ipsclass->member['id']) $can = 1;
		
		if ( $can == 0 )
		{
			$this->showMessage( array('msg' => 'no_permission', 'std' => 0 ));
		}
		
		//  ,    
		$post = $this->ipsclass->DB->simple_exec_query( array(  'select' => 'post_thanks, topic_id, author_id', 
																'from'   => 'posts', 
																'where'  => 'pid = ' . $post_id 
													  ) 	);
													  
		//  
		if ( (!$post['topic_id']) or ($post['topic_id'] != $topic_id) )
		{
			$this->showMessage( array('msg' => 'no_permission', 'std' => 0 ));
		}
		
		//    
		if ($post['author_id'])
		{
			//    
			$author = $this->ipsclass->DB->simple_exec_query( array(    'select' => 'mgroup, thanks_point', 
																		'from'   => 'members', 
																		'where'  => 'id = ' . $post['author_id'] 
															) 		);
		}
		else
		{
			//   - 
			$author['mgroup'] = $this->ipsclass->vars['guest_group'];
			$author['thanks_point'] = 0;
		}
		
		//  
		/*
		if (   ( ($this->ipsclass->vars['thanks_forum_lim']) and (!in_array($forum_id, explode(',',$this->ipsclass->vars['thanks_forums']))) )
			or ( ($this->ipsclass->vars['thanks_from_grp_lim']) and (!in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_from_groups']))) )
			or ( ($this->ipsclass->vars['thanks_to_grp_lim']) and (!in_array($author['mgroup'], explode(',',$this->ipsclass->vars['thanks_to_groups']))) )
			or (!$this->ipsclass->member['id'])   )
		{
			$this->showMessage( array('msg' => 'no_permission', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
		*/

		//  ,   ""
		$member_thanks = explode( ',', $post['post_thanks'] );
		
		//      0_  
		if ( $thx_member_id == $this->ipsclass->member['id'] AND !in_array($this->ipsclass->member['id'], $member_thanks) ) 
		{
			$this->showMessage( array('msg' => 'thx_say_thanks_first', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
		
		//--------------------------------------
		//    
		//--------------------------------------
		/*
		  :
		     .    ?
		$new_thanks = str_replace($thx_member_id, '', $post['post_thanks']);
		    ID=1     "1995,1045,432".
		     : 995,045,432
		^_^'
		,    . ( -,         :P )
		
		$new_thanks = str_replace(',,', ',', $new_thanks);
		$new_thanks = preg_replace('#,$#', '', $new_thanks);
		$new_thanks = preg_replace('#^,#', '', $new_thanks);
		*/
		
		//    .       ? ><
		$new_thanks = explode(',', $post['post_thanks']);
		foreach( $new_thanks as $k => $v)
		{
			if( $v == $thx_member_id) unset($new_thanks[ $k ]);
		}
		$new_thanks = implode(',', $new_thanks);
		$new_thanks = preg_replace('#,$#', '', $new_thanks);
			
		$this->ipsclass->DB->do_update( 'posts', array( 'post_thanks' => $new_thanks), 'pid = ' . $post_id );
		
		//   
		if ($post['author_id'])
		{
			$this->ipsclass->DB->do_update( 'members', array( 'thanks_point' => $author['thanks_point']-1 ), 'id = ' . $post['author_id'] );
		}
		
		// 
		if ($this->ajaxInUse == 1)
		{			
			//  ^^
			$this->class_ajax->return_html( $this->format_list($new_thanks, $post_id, $topic_id, $post['author_id']) );
		}
		else
		{
			$this->showMessage( array('msg' => 'thx_delete_success', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$post_id}" ) );
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //    HTML ,     AJAX
	//
    // msg 		=>   
    // std 		=>  1    'error'  'missing_files'
    // redirect =>   ajax    
    /*-------------------------------------------------------------------------*/ 
	
	function ShowMessage( $what )
	{
		//   
		if($this->ajaxInUse == 1)
		{
			if($what['std'] == 1)
			{
				$this->class_ajax->return_string('error');
			}
			else
			{
				$this->class_ajax->return_string($what['msg']);
			}
		}
		else
		{
			if(is_string($what['redirect']) AND strlen($what['redirect']) > 0)
			{
				$this->ipsclass->print->redirect_screen( $this->ipsclass->lang[ $what['msg'] ], $what['redirect'] );
			}
			else
			{
				$this->ipsclass->Error( array( 'LEVEL' => 1, 'MSG' => $what['msg']) );
			}
		}
		
		//   exit.   
		exit();
	}
	
	/*-------------------------------------------------------------------------*/
    //    
    //  eXtended reputation   .
    /*-------------------------------------------------------------------------*/ 
	
	function top_users()
	{
		if($this->ipsclass->vars['thanks_top_enable'])
		{
			//  .   
			$per_page = 30;
			$st = intval($this->ipsclass->input['st']);
			$order = ($this->ipsclass->input['order'] AND $this->ipsclass->input['order'] != '') ? $this->ipsclass->input['order'] : "desc";

			// 
			if($order == "asc")
			{
				$order = "thanks_point ASC";
				$opts = "<option value='desc'>{$this->ipsclass->lang['thx_top_sort_desc']}</option><option value='asc' selected='selected'>{$this->ipsclass->lang['thx_top_sort_asc']}</option>";
			}
			else
			{
				$order = "thanks_point DESC";
				$opts = "<option value='desc' selected='selected'>{$this->ipsclass->lang['thx_top_sort_desc']}</option><option value='asc'>{$this->ipsclass->lang['thx_top_sort_asc']}</option>";
			}

			$query = array( 'select'   => 'members_display_name, id, joined, posts, thanks_point, mgroup',
							'from'     => 'members',
							'where'    => 'thanks_point > 0',
							'order'    => $order,
							'limit'    => array( $st, $per_page)
							);

			$this->ipsclass->DB->simple_construct( $query );

			$this->ipsclass->DB->simple_exec();
			
			if($this->ipsclass->DB->get_num_rows())
			{
				while($row = $this->ipsclass->DB->fetch_row())
				{
					$row['joined'] = $this->ipsclass->get_date( $row['joined'], 'JOINED' );
					$row['members_display_name'] = $this->ipsclass->make_name_formatted( $row['members_display_name'], $row['mgroup'] );
					$rows .= "<tr>
	<td class='row2' align='left'><b><a href='{$this->ipsclass->base_url}showuser={$row['id']}'>{$row['members_display_name']}</a></b></td>
	<td class='row2' align='center'>{$row['joined']}</td>
	<td class='row2' align='center'>{$row['posts']}</td>
	<td class='row1' align='center'><b><a href='{$this->ipsclass->base_url}autocom=thanks&amp;type=history&amp;mid={$row['id']}'>{$row['thanks_point']}</a></b></td>
</tr>";
				}
				
				//   
				$this->ipsclass->DB->simple_construct( array( 'select'   => 'COUNT(*) as count',
															  'from'     => 'members',
															  'where'    => 'thanks_point > 0',
														) );
				$this->ipsclass->DB->simple_exec();
				$count = $this->ipsclass->DB->fetch_row();
				$count = intval($count['count']);
				
				$links = $this->ipsclass->build_pagelinks( array( 	'TOTAL_POSS'   => $count,
																	'PER_PAGE'     => $per_page,
																	'CUR_ST_VAL'   => $st,
																	'L_SINGLE'     => "",
																	'L_MULTI'      => $this->ipsclass->lang['pages'],
																	'BASE_URL'     => $this->ipsclass->base_url."autocom=thanks&amp;type=top_users"
														 )		);
			}
			else
			{
				$rows = "<tr><td class='row2' align='center' colspan='4'>{$this->ipsclass->lang['thx_top_no_data']}</td></tr>";
			}
			
			//        eXtended Reputation System?    
			$output .= "<div class='borderwrap'>
	<div class='maintitle'>{$this->ipsclass->lang['thx_top_users']}</div>
	<table class='ipbtable' cellspacing='1'>
	<tr>
		<th align='center' width='45%'>{$this->ipsclass->lang['thx_user']}</th>
		<th align='center' width='15%'>{$this->ipsclass->lang['thx_m_joined']}</th>
		<th align='center' width='20%'>{$this->ipsclass->lang['thx_m_posts']}</th>
		<th align='center' width='20%'>{$this->ipsclass->lang['thx_m_thanks_point']}</th>
	</tr>
	{$rows}
	<tr><td class='catend' colspan='4'><!-- no content --></td></tr>
	</table>
	<form action='{$this->ipsclass->base_url}' method='get'>
		<div class='formsubtitle' align='center'>
			<input type='hidden' name='autocom' value='thanks'>
			<input type='hidden' name='type' value='top_users'>
			{$this->ipsclass->lang['thx_top_sort_by']}
			<select name='order' class='forminput'>
			{$opts}
			</select>
			<input value='OK!' class='button' type='submit'>
		</div>
	</form>
</div><br />
{$links}";

			$this->ipsclass->print->add_output($output);
			$this->ipsclass->print->do_output( array( 	'TITLE' => $this->ipsclass->lang['thx_top_list'], 
														'JS' 	=> 0, 
														'NAV' 	=> $this->nav 
											 ) 		);
		}
	}
	
} // End class
//   andaril
?>