<?php

/*
+---------------------------------------------------------------------------
|   Invision Power Board
|   =============================================
|   by Matthew Mecham
|   (c) 2001 - 2009 Invision Power Services, Inc.
|   http://www.invisionpower.com
|   =============================================
|   Web: http://www.invisionboard.com
|   Licence Info: http://www.invisionboard.com/?license
+---------------------------------------------------------------------------
|
|   > Thanks lib functions for topics
|   > Module written by andaril http://ipbskins.ru
|   > Date started: 24.03.2009
|   > Module Version Number: 2.2.0
|
+--------------------------------------------------------------------------- 
|   > Last update: $Date:: 2009-08-13 18:07:42 +0400#$
|   > $Revision: 26 $
|   > $Author: a1 $ 
+---------------------------------------------------------------------------
*/

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded 'admin.php'.";
	exit();
}

//  
class func_thanks
{
	//   
	var $ipsclass;	
	
	/*-------------------------------------------------------------------------*/
    // 
    /*-------------------------------------------------------------------------*/ 
	
	function func_thanks( &$that )
	{
		$this->ipsclass =& $that;
		//  .       
		$this->ipsclass->load_language('lang_thanks');	
	}
			
	/*-------------------------------------------------------------------------*/
    //    ""  
    /*-------------------------------------------------------------------------*/ 
	
	function format_list( $who, $pid, $topic_id, $post_mid )
	{
		//    -  
		if ( $who == '' OR $pid == '' OR $topic_id == '') return '';
		
		//    ?
		if ( ( in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_view_groups'])) 
		OR !$this->ipsclass->vars['thanks_view_grp_lim'] ) )
		{
			//  
			$this->ipsclass->DB->simple_construct( array( 'select'  => 'members_display_name, id, mgroup',
														  'from'	=> 'members',
														  'where'   => " id IN ({$who})",
												 )		);
			$this->ipsclass->DB->simple_exec();

			// ,     
			while($who_thanks = $this->ipsclass->DB->fetch_row())
			{
				$who_thanks['members_display_name'] = $this->ipsclass->make_name_formatted( $who_thanks['members_display_name'], $who_thanks['mgroup'] );
				
				//     :)
				//  Ritsuka @ ibr (thx_mid  )
				$delete_img = ( $this->edit_permissions() OR ($who_thanks['id'] == $this->ipsclass->member['id'])) 
				? "&nbsp;<a href='{$this->ipsclass->base_url}autocom=thanks&amp;type=delete&amp;thx_mid={$who_thanks['id']}&amp;pid={$pid}&amp;t={$topic_id}' 
				onclick='return thx_delete({$who_thanks['id']}, {$pid}, {$post_mid});' ><img id='thx_img_{$pid}_{$who_thanks['id']}' src='style_images/<#IMG_DIR#>/thx_del_inactive.gif' alt='{$this->ipsclass->lang['thx_delete_action']}' 
				onMouseOver='document.getElementById(\"thx_img_{$pid}_{$who_thanks['id']}\").src=\"style_images/<#IMG_DIR#>/thx_del_active.gif\"' 
				onMouseOut='document.getElementById(\"thx_img_{$pid}_{$who_thanks['id']}\").src=\"style_images/<#IMG_DIR#>/thx_del_inactive.gif\"' /></a>" 
				: "";
				
				$show_thanks .= "<a href='{$this->ipsclass->base_url}showuser={$who_thanks['id']}' target='_blank'>{$who_thanks['members_display_name']}</a>{$delete_img}, ";
			}
			
			//      :)
			$show_thanks = preg_replace( "/, $/", "", $show_thanks );
		
			return "<div id='thank{$pid}'><br /><br /><div class='thin'><i>{$this->ipsclass->lang['thx_thanks_told']}:</i><div class='signature'>{$show_thanks}</div></div></div>";
		}
		else
		{
			//  ,    
			$this->showMessage( array('msg' => 'thx_added', 'std' => 0, 'redirect' => "showtopic={$topic_id}&amp;view=findpost&amp;p={$pid}" ) );
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //        topic.php
    /*-------------------------------------------------------------------------*/ 
	
	function button_and_list_for_topics( &$row, $forum_id, $poster_group )
	{
		$member_thanks = explode(',',$row['post_thanks']);
		
		if (   ( in_array($forum_id, explode(',',$this->ipsclass->vars['thanks_forums'])) or (!$this->ipsclass->vars['thanks_forum_lim']) )
			and ( in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_from_groups'])) or (!$this->ipsclass->vars['thanks_from_grp_lim']) )
			and ( in_array($poster_group, explode(',',$this->ipsclass->vars['thanks_to_groups'])) or (!$this->ipsclass->vars['thanks_to_grp_lim']) )
			and ($this->ipsclass->member['id'])   )
		{
			if ( (!in_array($this->ipsclass->member['id'],$member_thanks)) and ($this->ipsclass->member['id'] != $row['author_id']) )
			{
				$row['thanks_button'] = $this->ipsclass->compiled_templates['skin_topic']->button_thanks($row['pid'], $row['author_id'] );
			}
		}
		
		if (   ( in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_view_groups'])) or (!$this->ipsclass->vars['thanks_view_grp_lim']) )
			and ( (count($member_thanks) > 0) && ($member_thanks[0] != "") )   )
		{
			$in_thanks = (count($member_thanks)==2) ? $row['post_thanks'] : implode(',',$member_thanks);
			$row['who_thanks'] = $this->format_list($in_thanks, $row['pid'], $row['topic_id'], $row['author_id']);
		}
	}
	
	/*-------------------------------------------------------------------------*/
    //   / 
    /*-------------------------------------------------------------------------*/ 
	
	function edit_permissions()
	{
		// 
		return (bool) (in_array($this->ipsclass->member['mgroup'], explode(',',$this->ipsclass->vars['thanks_moder_groups'])) 
						OR $this->ipsclass->member['g_is_supmod'] 
						OR $this->ipsclass->member['g_access_cp'] );
	}
	
	/*-------------------------------------------------------------------------*/
    //   
    /*-------------------------------------------------------------------------*/ 
	
	function thanks_points( &$member, $additional_info = '' )
	{
		//      
		if(isset($additional_info) AND count($additional_info) AND is_array($additional_info))
		{
			$member['thanks_point'] = $additional_info['thanks_point'];
			unset($additional_info);
		}
		
		// ""/""
		//  -,      
		
		//   md-bodi@
		//    , .
		//if ($member['thanks_point'] %10 >= 2) and ($members['thanks_point'] % <= 4) and ($members['thanks_point']/10 != 1)
		
		if(($member['thanks_point'] <= 1) 
		OR ($member['thanks_point'] >= 5 AND $member['thanks_point'] <= 21) 
		OR (($member['thanks_point'] % 10 < 2) OR ($member['thanks_point'] % 10 > 4) AND ($member['thanks_point'] < 10 OR $member['thanks_point'] > 20)))
		{
			$lang_bit = $this->ipsclass->lang['thx_thanks_told_suf_b'];
		}
		else
		{
			$lang_bit = $this->ipsclass->lang['thx_thanks_told_suf_a'];
		}
		
		// 
		if ($this->ipsclass->vars['thanks_history_enable'])
		{
			$member['thanks_point'] = "{$this->ipsclass->lang['thx_thanks_told_count']} <span id='thank_count{$member['id']}'>{$member['thanks_point']}</span> <a href='{$this->ipsclass->base_url}autocom=thanks&amp;type=history&amp;mid={$member['id']}' target='_blank'>{$lang_bit}</a><br />";
		}
		else
		{
			$member['thanks_point'] = "{$this->ipsclass->lang['thx_thanks_told_count']} <span id='thank_count{$member['id']}'>{$member['thanks_point']}</span>{$this->ipsclass->lang['thx_thanks_told_suf']}<br />";
		}
	}
	
} // End class

//   andaril
?>